

#if !defined(GAMENOCHECKZ) || (!defined(GAMETRANS) && !defined(GAMENOZSET))
   int      *zdata = (int *)proc->zbuff.zdata;
#endif

   int      winx = proc->zbuff.maxx;
   int      winy = proc->zbuff.maxy;
   unsigned int *idata;

   edgetype *aet = NULL;
   edgetype *ptr, *qtr, *head, **btr;
   int      scany, scanxy, start, end;

   face_type *flist = &pot->flist[face];
   vector3f  gcolor;
   float     prenum;
   union     { int i; float f; } prediv;
   float     dy, predx;

   unsigned int *palette;
   texbase  *texptr;
   unsigned char *mapptr;
   fixed_pt uv[2], duv[2];
   int xshift;
   int yshift;
   int ymask;
   texture_block256 *tblock;

   flt2int_type d0;
   float div;
   vector4uc rcolor;
   unsigned char *bytelut = pbyte_lut;

   unsigned char *bytemult = byte_mult;
   unsigned char *bytemultseg[3];
   vector4uc tempcolor;

   tob->query_data(face, TEXTURE2D_QUERY_UNIT_TEXTURE, &last_frame, &texptr);
   tblock = (texture_block256 *)texptr->query_data();
   mapptr = tblock->tob.data;
   xshift = (NORMALIZED_FIXED_PRECISION-texptr->bitx);
   yshift = (NORMALIZED_FIXED_PRECISION-texptr->bity);
   ymask  = (0x00ffffff >> yshift)<<texptr->bitx;
   
   idata = proc->zbuff.data;
   palette = tblock->ipalette;

   yshift -= texptr->bitx;

   head = et[face];
   et[face] = NULL;

   scany  = head->starty;
   scanxy = scany*winx;

// addeqarray3(gcolor, flist->color, flist->ambient);
   gcolor[0] = flist->color[0] + flist->ambient[0];

   F2I(d0, gcolor[0]);
//   F2I(d1, gcolor[1]);
//   F2I(d2, gcolor[2]);

   bytemultseg[0] = bytemult + (bytelut[d0.iflt2int[0]]<<8);
//   bytemultseg[1] = bytemult + (bytelut[d1.iflt2int[0]]<<8);
//   bytemultseg[2] = bytemult + (bytelut[d2.iflt2int[0]]<<8);

   div = 1.0f/flist->normal[3];
   flist->normal[0] *= div;
   flist->normal[1] *= div;

   prenum = parm->imscale*flist->normal[0];
   dy     = parm->imscale*flist->normal[1];
   predx  = parm->vrc[0]*flist->normal[0] + parm->vrc[2]*flist->normal[1] - flist->normal[2]*div;

   while (scany < winy) {

      // add new edges to aet
      while (head && head->starty == scany) {
         ptr = head;
         head = (edgetype *)head->next;
         ptr->start.point[1] = predx + ptr->starty*dy;
         fixed_sortbucket(&aet, ptr);
      }

      if (!aet)
         break;

      // scan each pair of edges
      for (ptr=aet; ptr; ptr=(edgetype *)qtr->next) {

         qtr = (edgetype *)ptr->next;

         start = FIXED_TO_INT(ptr->start.fxpoint[0]);
         end   = FIXED_TO_INT(qtr->start.fxpoint[0]);

         if (start == end)
            continue;

         // setup texture
         div = ((gengine *)proc)->xbuff[end-start];
         copyarray2(uv, ptr->start.fxuvz);

         duv[0] = (int)((qtr->start.fxuvz[0] - uv[0]) * div);
         duv[1] = (int)((qtr->start.fxuvz[1] - uv[1]) * div);

         prediv.f = ptr->start.point[1] + start*prenum;

         for (start += scanxy, end += scanxy; start<end; prediv.f += prenum, start++, uv[0] += duv[0], uv[1] += duv[1]) {

#ifndef GAMENOCHECKZ
            if (prediv.i <= zdata[start])
	       continue;
#endif

            *(unsigned int *)tempcolor = palette[mapptr[((uv[1] >> yshift) & ymask) | (NORMALIZED_FIXED_REMAINDER(uv[0]) >> xshift)]];

            settexcolor(rcolor, bytemultseg[0], tempcolor);

#ifdef GAMETRANS
            set_trans(idata[start], rcolor);
#elif defined GAMENOZSET
            set_nzbuff(idata[start], rcolor);
#else
            set_zbuff(zdata[start], idata[start], prediv.i, rcolor);
#endif

         }

      }

      // increment counters
      scany++;
      scanxy += winx;

      if (scany >= winy)
         break;

      // update aet for next row
      for (ptr = aet, btr = &aet; ptr;) {

         if (scany >= ptr->endy) {
            *btr = (edgetype *)ptr->next;
            proc->control->push(MM_EDGE, ptr);
            ptr = *btr;
            continue;
         }

         addarray2(ptr->start.fxuvz, ptr->fxduvz);
         ptr->start.fxpoint[0] += ptr->fxdx;
         ptr->start.point[1]   += dy;
         btr = (edgetype **)&ptr->next;
         ptr = (edgetype *)ptr->next;
      }

   }

   // garbage collection

   while (aet) {
      ptr=aet;
      aet=(edgetype *)aet->next;
      proc->control->push(MM_EDGE, ptr);
   }

   while (head) {
      ptr=head;
      head=(edgetype *)head->next;
      proc->control->push(MM_EDGE, ptr);
   }

